<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="header d-flex flex-row px-4 bg-black text-white justify-content-between">
  <div class="d-flex flex-row">
    <div
      class="p-2 pointer"
      routerLink="/"
      [innerText]="commonMessages.APP_NAME">
    </div>

    <fa-icon
      class="ms-2 p-2 align-self-center pointer"
      [icon]="homeIcon"
      routerLink="/"
      [title]="messages.HEADER_ICON_TITLE_HOME">
    </fa-icon>

    <div
      class="ms-4 bg-dark desk-info d-flex flex-column pointer"
      [routerLink]="'/tenant/'+ selectedDesk.tenantId + '/desk/' + selectedDesk?.id"
      *ngIf="!!selectedDesk">
      <div
        class="ms-1 me-1 text-center small text-overflow-ellipsis overflow-hidden text-nowrap"
        [innerText]="selectedDesk.shortName"
        [title]="selectedDesk.name">
      </div>
      <div class="d-flex justify-content-center pointer-badge-container">
        <div class="d-flex justify-content-center custom-badge-size" appClickStopPropagation>
          <span
            *ngIf="deskCount?.lateFoldersCount > 0"
            class="badge badge-late desk-badge me-1"
            routerLink="/tenant/{{ selectedDesk.tenantId }}/desk/{{ selectedDesk.id }}/late"
            [ngbTooltip]="stateEnum.Late | stateName"
            openDelay="300"
            [innerText]="deskCount.lateFoldersCount">
          </span>
          <span
            *ngIf="deskCount?.finishedFoldersCount > 0"
            class="badge badge-finished desk-badge me-1"
            routerLink="/tenant/{{ selectedDesk.tenantId }}/desk/{{ selectedDesk.id }}/finished"
            [ngbTooltip]="stateEnum.Finished | stateName"
            openDelay="300"
            [innerText]="deskCount.finishedFoldersCount">
          </span>
          <span
            *ngIf="deskCount?.rejectedFoldersCount > 0"
            class="badge badge-rejected desk-badge me-1"
            routerLink="/tenant/{{ selectedDesk.tenantId }}/desk/{{ selectedDesk.id }}/rejected"
            [ngbTooltip]="stateEnum.Rejected | stateName"
            openDelay="300"
            [innerText]="deskCount.rejectedFoldersCount">
          </span>
          <span
            *ngIf="deskCount?.draftFoldersCount > 0"
            class="badge badge-draft desk-badge me-1"
            routerLink="/tenant/{{ selectedDesk.tenantId }}/desk/{{ selectedDesk.id }}/draft"
            [ngbTooltip]="stateEnum.Draft | stateName"
            openDelay="300"
            [innerText]="deskCount.draftFoldersCount">
          </span>
          <span
            class="badge badge-pending desk-badge me-1"
            routerLink="/tenant/{{ selectedDesk.tenantId }}/desk/{{ selectedDesk.id }}"
            [ngbTooltip]="stateEnum.Pending | stateName"
            openDelay="300"
            [innerText]="deskCount?.pendingFoldersCount">
          </span>
          <span
            *ngIf="computedDelegatedCount"
            class="badge badge-delegated desk-badge"
            routerLink="/tenant/{{ selectedDesk.tenantId }}/desk/{{ selectedDesk.id }}/delegated"
            [ngbTooltip]="stateEnum.Delegated | stateName"
            openDelay="300"
            [innerText]="computedDelegatedCount">
          </span>
        </div>
      </div>
    </div>

    <ng-container *ngIf="isInGlobalErrorState">
      <fa-icon
        role="alert"
        [title]="globalErrorTitle"
        class="ms-4 p-2 align-self-center"
        [icon]="commonIcons.WARNING_ICON"
        [classes]="['ls-danger']"
        (click)="openErrorPopup()"
        [ngbTooltip]="globalErrorTooltip"
        [openDelay]="300">
      </fa-icon>
    </ng-container>
  </div>

  <div class="d-flex flex-row pointer">

    <a
      [routerLink]="getAdminPath()"
      *ngIf="isUserAdmin"
      class="align-self-center text-white"
      [title]="messages.HEADER_ICON_TITLE_ADMIN">
      <fa-icon
        class="p-2 align-self-center"
        [icon]="wrenchIcon">
      </fa-icon>
    </a>

    <app-global-search-bar class="ms-2"></app-global-search-bar>

    <div class="header-menu d-flex flex-column ms-2 align-items-end">
      <div class="header-menu-label w-100 h-100 d-flex flex-row align-items-center justify-content-end text-end">
        <div
          *ngIf="!!currentUser"
          class="w-100 text-nowrap overflow-hidden text-overflow-ellipsis"
          [innerText]="prettyPrintUserFn(currentUser)">
        </div>
        <fa-icon
          class="p-2 align-self-center"
          [icon]="arrowDownIcon">
        </fa-icon>
      </div>

      <div class="header-menu-dropdown position-relative flex-column bg-black text-nowrap rounded-bottom pb-1">

        <div
          *ngIf="showTrashBin"
          class="p-2"
          routerLink="/trash-bin">
          <fa-icon
            class="p-2"
            [icon]="commonIcons.DELETE_ICON">
          </fa-icon>
          <span [innerText]="messages.HEADER_MENU_TRASH_BIN"></span>
        </div>
        <!--        <div-->
        <!--          class="p-2"-->
        <!--          routerLink="/stats">-->
        <!--          <fa-icon-->
        <!--            class="p-2"-->
        <!--            [icon]="chartBarIcon">-->
        <!--          </fa-icon>-->
        <!--          <span [innerText]="messages.HEADER_MENU_STATS"></span>-->
        <!--        </div>-->
        <div
          class="p-2"
          routerLink="/profile">
          <fa-icon
            class="p-2"
            [icon]="userProfileIcon">
          </fa-icon>
          <span [innerText]="messages.HEADER_MENU_PROFILE"></span>
        </div>
        <div
          class="p-2"
          routerLink="/gdpr">
          <fa-icon
            class="p-2"
            [icon]="gdprIcon">
          </fa-icon>
          <span [innerText]="messages.HEADER_MENU_GDPR"></span>
        </div>
        <div
          class="p-2"
          routerLink="/about">
          <fa-icon
            class="p-2"
            [icon]="aboutIcon">
          </fa-icon>
          <span [innerText]="messages.HEADER_MENU_ABOUT"></span>
        </div>
        <div
          class="p-2"
          (click)="onLogoutButtonClicked()">
          <fa-icon
            class="p-2"
            [icon]="logoutIcon">
          </fa-icon>
          <span [innerText]="messages.HEADER_MENU_LOGOUT"></span>
        </div>
      </div>
    </div>
  </div>


</div>
